#include "Movable.h"
#include "Sprite.h"
#include "Vram.h"
#include "VVram.h"
#include "Chars.h"
#include "Stage.h"

constexpr byte InvalidY = 0x80;
Sprite[SpriteCount] Sprites;

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->y = InvalidY;
    }
}


void ShowSprite(ptr<Movable> pMovable, byte code)
{
    ptr<Sprite> p;
    ptr<byte> pd;
    p = Sprites + pMovable->sprite;
    p->x = pMovable->x;
    p->y = pMovable->y;
    pd = p->codes;
    repeat (4) {
        *pd = code;
        ++pd;
        ++code;
    }
}


void ShowSpriteS(ptr<Movable> pMovable, ptr<byte> pChars)
{
    ptr<Sprite> p;
    ptr<byte> pd;
    p = Sprites + pMovable->sprite;
    p->x = pMovable->x;
    p->y = pMovable->y;
    pd = p->codes;
    repeat (4) {
        *pd = *pChars;
        ++pd;
        ++pChars;
    }
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->y = InvalidY;
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->y != InvalidY) {
            ptr<byte> pVVram;
            byte y;
            y = p->y - topY;
            if (y < VVramHeight) {
                ptr<byte> pc;
                pVVram = VVramPtr(p->x, y);
                pc = p->codes;
                pVVram[0] = *pc; ++pc;
                pVVram[1] = *pc; ++pc;
                ++y;
                if (y < VVramHeight) {
                    pVVram[VVramWidth] = *pc; ++pc;
                    pVVram[VVramWidth + 1] = *pc;
                }
            }
        }
    }
}
